Loading...
Searching...
No Matches
Crapview Class Reference

Crapview. More...

`#include <crapview.h>`

## Public Member Functions

const int & | getDialogsLevel ()
| Returns the Dialogs level.
void | setDialogsLevel (const int &new_level)
| Sets the new Dialogs level.
void | setChartsTheme (const int &new_theme_id)
| Sets the new charts theme to use.
void | setDbPath (const std::string &path)
| Sets the new path for the logs Collection database. More...
const QString | parseBooleanFilter (const QString &filter_str)
| Parses a filter for a database field with boolean type. More...
const QString | parseNumericFilter (const QString &filter_str)
| Parses a filter for a log field with integer type. More...
const QString | parseTextualFilter (const QString &filter_str)
| Parses a filter for a log field with text type. More...
const QString | getLogFieldString (const int &field_id)
| Returns the printable log field corresponding to the given ID. More...
const int | getLogFieldID (const QString &field_str)
| Returns the log field ID corresponding to the given printable field. More...
const int | getMonthNumber (const QString &month_str)
| Returns the month number corresponding to the given printable month. More...
void | refreshDates ()
| Refreshes the list of the dates which are available in the database.
void | clearDates ()
| Erases the list of available dates.
const QStringList | getYears (const QString &web_server)
| Returns le list of available years, for the given web server. More...
const QStringList | getMonths (const QString &web_server, const QString &year)
| Returns le list of available months in the given year, for the given web server. More...
const QStringList | getDays (const QString &web_server, const QString &year, const QString &month)
| Returns le list of available days in the given month and year, for the given web server. More...
const QStringList | getHours ()
| Returns all the hours of the day. More...
const QStringList | getFields (const std::string &tab)
| Returns a list of the fields for the given tab. More...
void | updateWarn (QTableWidget *table, const QString &web_server)
| Updates the database applying the changes which have been made to the table. More...
void | drawWarn (QTableWidget *table, QtCharts::QChartView *chart, const QChart::ChartTheme &theme, const std::unordered_map< std::string, QFont > &fonts, const QString &web_server, const QString &year, const QString &month, const QString &day, const QString &hour)
| Draws the chart and fills the table for the Warnings stats. More...
void | drawSpeed (QTableWidget *table, QtCharts::QChartView *chart, const QChart::ChartTheme &theme, const std::unordered_map< std::string, QFont > &fonts, const QString &web_server, const QString &year, const QString &month, const QString &day, const QString &protocol, const QString &method, const QString &uri, const QString &query, const QString &response)
| Draws the chart and fills the table for the Speed stats. More...
void | drawCount (QTableWidget *table, QtCharts::QChartView *chart, const QChart::ChartTheme &theme, const std::unordered_map< std::string, QFont > &fonts, const QString &web_server, const QString &year, const QString &month, const QString &day, const QString &field)
| Draws the chart and fills the table for the Counts stats. More...
void | drawDay (QtCharts::QChartView *chart, const QChart::ChartTheme &theme, const std::unordered_map< std::string, QFont > &fonts, const QString &web_server, const QString &from_year, const QString &from_month, const QString &from_day, const QString &to_year, const QString &to_month, const QString &to_day, const QString &field, const QString &filter)
| Draws the chart for the Daytime stats. More...

void

drawRelat (QtCharts::QChartView *chart, const QChart::ChartTheme &theme, const std::unordered_map< std::string, QFont > &fonts, const QString &web_server, const QString &from_year, const QString &from_month, const QString &from_day, const QString &to_year, const QString &to_month, const QString &to_day, const QString &field_1, const QString &filter_1, const QString &field_2, const QString &filter_2)

| Draws the chart for the Relational stats. More...
const bool | calcGlobals (std::vector< std::tuple< QString, QString > > &recur_list, std::vector< std::tuple< QString, QString > > &traffic_list, std::vector< std::tuple< QString, QString > > &perf_list, std::vector< QString > &work_list, const QString &web_server)
| Retrieves the data to fill the Globals stats. More...

## Private Member Functions

const QString | printableDate (const int &year, const int &month, const int &day)
| Returns a string of the given date in the format YYY-MM-DD. More...
const QString | printableTime (const int &hour, const int &minute, const int &second)
| Returns a string of the given time in the format HH:MM:SS. More...
const QString | printableWarn (const int &value)
| Returns a string corresponding to the given value. More...

## Detailed Description

Crapview.

Performs operations related to the visualization of the statistics

## Member Function Documentation

## calcGlobals()

const bool Crapview::calcGlobals | ( | std::vector< std::tuple< QString, QString > > & | recur_list,
|  | std::vector< std::tuple< QString, QString > > & | traffic_list,
|  | std::vector< std::tuple< QString, QString > > & | perf_list,
|  | std::vector< QString > & | work_list,
|  | const QString & | web_server
| ) |  |

Retrieves the data to fill the Globals stats.

Parameters

  recur_list | The list which will hold the printable recurrencies
  traffic_list | The list which will hold the printable traffics
  perf_list | The list which will hold the printable performances
  work_list | The list which will hold the printable overall work infos
  web_server | The printable Web Server name

Returns
  Whether the operation has been successful or not

## drawCount()

void Crapview::drawCount | ( | QTableWidget * | table,
|  | QtCharts::QChartView * | chart,
|  | const QChart::ChartTheme & | theme,
|  | const std::unordered_map< std::string, QFont > & | fonts,
|  | const QString & | web_server,
|  | const QString & | year,
|  | const QString & | month,
|  | const QString & | day,
|  | const QString & | field
| ) |  |

Draws the chart and fills the table for the Counts stats.

Parameters

  table | The table widget
  chart | The chart widget
  theme | The theme to use for the chart
  fonts | The map holding the fonts
  web_server | The printable Web Server name
  year | The year
  month | The printable month name
  day | The day
  field | The printable log field

## drawDay()

void Crapview::drawDay | ( | QtCharts::QChartView * | chart,
|  | const QChart::ChartTheme & | theme,
|  | const std::unordered_map< std::string, QFont > & | fonts,
|  | const QString & | web_server,
|  | const QString & | from_year,
|  | const QString & | from_month,
|  | const QString & | from_day,
|  | const QString & | to_year,
|  | const QString & | to_month,
|  | const QString & | to_day,
|  | const QString & | field,
|  | const QString & | filter
| ) |  |

Draws the chart for the Daytime stats.

Parameters

  chart | The chart widget
  theme | The theme to use for the chart
  fonts | The map holding the fonts
  web_server | The printable Web Server name
  year | The initial year
  month | The initial printable month name
  day | The initial day
  year | The final year
  month | The final printable month name
  day | The finl day
  field | The printable log field
  filter | The give filter string

## drawRelat()

void Crapview::drawRelat | ( | QtCharts::QChartView * | chart,
|  | const QChart::ChartTheme & | theme,
|  | const std::unordered_map< std::string, QFont > & | fonts,
|  | const QString & | web_server,
|  | const QString & | from_year,
|  | const QString & | from_month,
|  | const QString & | from_day,
|  | const QString & | to_year,
|  | const QString & | to_month,
|  | const QString & | to_day,
|  | const QString & | field_1,
|  | const QString & | filter_1,
|  | const QString & | field_2,
|  | const QString & | filter_2
| ) |  |

Draws the chart for the Relational stats.

Parameters

  chart | The chart widget
  theme | The theme to use for the chart
  fonts | The map holding the fonts
  web_server | The printable Web Server name
  year | The initial year
  month | The initial printable month name
  day | The initial day
  year | The final year
  month | The final printable month name
  day | The finl day
  field_1 | The first printable log field
  filter_1 | The give filter string for the first field
  field_2 | The second printable log field
  filter_2 | The give filter string for the second field

## drawSpeed()

void Crapview::drawSpeed | ( | QTableWidget * | table,
|  | QtCharts::QChartView * | chart,
|  | const QChart::ChartTheme & | theme,
|  | const std::unordered_map< std::string, QFont > & | fonts,
|  | const QString & | web_server,
|  | const QString & | year,
|  | const QString & | month,
|  | const QString & | day,
|  | const QString & | protocol,
|  | const QString & | method,
|  | const QString & | uri,
|  | const QString & | query,
|  | const QString & | response
| ) |  |

Draws the chart and fills the table for the Speed stats.

Parameters

  table | The table widget
  chart | The chart widget
  theme | The theme to use for the chart
  fonts | The map holding the fonts
  web_server | The printable Web Server name
  year | The year
  month | The printable month name
  day | The day
  protocol | The given filter for the Protocol
  method | The given filter for the Method
  uri | The given filter for the URI
  query | The given filter for the Query
  response | The given filter for the Response

## drawWarn()

void Crapview::drawWarn | ( | QTableWidget * | table,
|  | QtCharts::QChartView * | chart,
|  | const QChart::ChartTheme & | theme,
|  | const std::unordered_map< std::string, QFont > & | fonts,
|  | const QString & | web_server,
|  | const QString & | year,
|  | const QString & | month,
|  | const QString & | day,
|  | const QString & | hour
| ) |  |

Draws the chart and fills the table for the Warnings stats.

Parameters

  table | The table widget
  chart | The chart widget
  theme | The theme to use for the chart
  fonts | The map holding the fonts
  web_server | The printable Web Server name
  year | The year
  month | The printable month name
  day | The day
  hout | The hour

## getDays()

const QStringList Crapview::getDays | ( | const QString & | web_server,
|  | const QString & | year,
|  | const QString & | month
| ) |  |

Returns le list of available days in the given month and year, for the given web server.

Parameters

  web_server | The printable Web Server name
  year | The year
  month | The printable month name

Returns
  The list of days which are avaliable

## getFields()

const QStringList Crapview::getFields | ( | const std::string & | tab | ) |

Returns a list of the fields for the given tab.

Parameters

  tab | The stats tab

Returns
  The list of fields

## getHours()

const QStringList Crapview::getHours | ( |  | ) |

Returns all the hours of the day.

Returns
  The list of all the hours

## getLogFieldID()

const int Crapview::getLogFieldID | ( | const QString & | field_str | ) |

Returns the log field ID corresponding to the given printable field.

Parameters

  field_str | The log field

Returns
  The ID of the log field

## getLogFieldString()

const QString Crapview::getLogFieldString | ( | const int & | field_id | ) |

Returns the printable log field corresponding to the given ID.

The field gets translated to be printable before being returned

Parameters

  field_id | The ID of the log fiels

Returns
  The printable field

## getMonthNumber()

const int Crapview::getMonthNumber | ( | const QString & | month_str | ) |

Returns the month number corresponding to the given printable month.

Parameters

  month_Str | The printable month name

Returns
  The month number

## getMonths()

const QStringList Crapview::getMonths | ( | const QString & | web_server,
|  | const QString & | year
| ) |  |

Returns le list of available months in the given year, for the given web server.

Parameters

  web_server | The printable Web Server name
  year | The year

Returns
  The list of printable month names which are avaliable

## getYears()

const QStringList Crapview::getYears | ( | const QString & | web_server | ) |

Returns le list of available years, for the given web server.

Parameters

  web_server | The printable Web Server name

Returns
  The list of yearss which are avaliable

## parseBooleanFilter()

const QString Crapview::parseBooleanFilter | ( | const QString & | filter_str | ) |

Parses a filter for a database field with boolean type.

Parameters

  field_str | The given filter

Returns
  The resulting filter to apply to the query

## parseNumericFilter()

const QString Crapview::parseNumericFilter | ( | const QString & | filter_str | ) |

Parses a filter for a log field with integer type.

Parameters

  field_str | The given filter

Returns
  The resulting filter to apply to the query

## parseTextualFilter()

const QString Crapview::parseTextualFilter | ( | const QString & | filter_str | ) |

Parses a filter for a log field with text type.

Parameters

  field_str | The given filter

Returns
  The resulting filter to apply to the query

## printableDate()

const QString Crapview::printableDate | ( | const int & | year,
|  | const int & | month,
|  | const int & | day
| ) |  |

private

Returns a string of the given date in the format YYY-MM-DD.

Parameters

  year | The year
  month | The month
  day | The day

Returns
  The printable date

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  year | The year
  month | The month
  day | The day

Returns
  The printable date

## printableTime()

const QString Crapview::printableTime | ( | const int & | hour,
|  | const int & | minute,
|  | const int & | second
| ) |  |

private

Returns a string of the given time in the format HH:MM:SS.

Parameters

  hour | The hour
  minut | The minute
  second | The second

Returns
  The printable time

## printableWarn()

const QString Crapview::printableWarn | ( | const int & | value | ) |

private

Returns a string corresponding to the given value.

Used to convert numeric booleans [0,1] to string [FALSE,TRUE]

Parameters

  value | The value to convert

Returns
  The corresponding printable string

## setDbPath()

void Crapview::setDbPath | ( | const std::string & | path | ) |

Sets the new path for the logs Collection database.

See also
  DbQuery::setDbPath()

## updateWarn()

void Crapview::updateWarn | ( | QTableWidget * | table,
|  | const QString & | web_server
| ) |  |

Updates the database applying the changes which have been made to the table.

Parameters

  table | The Warnings stats table
  web_server | The printable Web Server name

The documentation for this class was generated from the following files:

- logdoctor/modules/crapview/crapview.h
- logdoctor/modules/crapview/crapview.cpp